{   
    Single Precision Complex Multiply Assembler Reference Code

    Calling Parameters

         I0 -> Real Part of ar + j ai
         I1 -> Imag Part of ar + j ai
         I2 -> Real Part of cr + j ci
         I3 -> Imag Part of cr + j ci
         I4 -> Real Part of br + j bi in program memory
         I5 -> Imag Part of br + j bi in program memory

         li = 0 ; i=1...5
         mi = 1 ; i=1...5
                
    Altered Registers

         MX0, MY0, MX1, MY1, MR
         I0, L0, M0
         I1, L1, M1
         I2, L2, M2
         I3, L3, M3
         I4, L4, M4
         I5, L5, M5

    Reference: none

    Author :Juan Martinez Velarde, IS2, RWTH Aachen, 10.05.1994
}

.MODULE/ram/abs=0x2        _complex_multiply_;

.var/dm/ram/abs=0x3400     _a_[2];
.init                      _a_: 2,1;
.var/pm/ram/abs=0x0        _b_[2];
.init                      _b_: 512,1280;{0x000200, 0x000500} 
.var/dm/ram/abs=0x3402     _c_[2];
.init                      _c_: 0,0;

.entry        complex_multiply;
complex_multiply:

        i0=^_a_    ; l0=0 ; m0=1 ; 
        i1=^_a_ +1 ; l1=0 ; m1=1 ;        
        i2=^_c_    ; l2=0 ; m2=0 ; 
        i3=^_c_ +1 ; l3=0 ; m3=0 ; 
        i4=^_b_    ; l4=0 ; m4=1 ;
        i5=^_b_ +1 ; l5=0 ; m5=1 ;

        ENA M_MODE ; { enable integer MAC result replacement mode }

START_PROFILING:

        mr=0,mx0=dm(i0,m0),my0=pm(i4,m4);
        mx1=dm(i1,m1),my1=pm(i5,m5),mr=mx0*my0(ss) ;
        mr=mr-mx1*my1(ss) ; 
        dm(i2,m2)=mr0,mr=mx1*my0(ss); 
        mr=mr+mx0*my1(ss);
        dm(i3,m3)=mr0 ;

END_PROFILING:

end:        JUMP        end ; 

.ENDMOD;