; /*
;  * benchmark program:   complex_multiply_arc.asm
;  * 
;  * benchmark suite:     DSP-kernel
;  * 
;  * description:         complex_multiply - filter benchmarking
;  * 
;  * reference code:      target assembly
;  * 
;  * f. verification:     with printf function
;  * 
;  *  organization:        Aachen University of Technology - IS2 
;  *                       DSP Tools Group
;  *                       phone:  +49(241)807887 
;  *                       fax:    +49(241)8888195
;  *                       e-mail: zivojnov@ert.rwth-aachen.de 
;  *
;  * author:              Juan Martinez Velarde
;  * 
;  * history:             09-05-94 creation and profiling (Martinez Velarde)
;  * 
;  */

	section complex_multiply_arc
	opt so,nomd,cc

	org	x:

F___a	dc	2	; ar
	dc	1	; ai
F___c	dc	0	; cr
	dc	0	; ci

	org 	y:

F___b	dc	2	; br
	dc	5	; bi

LC0     dc	'cr',$3D,$25,'i',$0A,$0A,$00

LC1     dc	'ci',$3D,$25,'i',$0A,$0A,$00

	org	p:

	global	Fmain
Fmain
	move	ssh,y:(r6)+
	move	#F___a,r3
	move 	#F___b,r4
	move	#F___c,r2
	nop

ASM_APP_0
	START_PROFILING:
ASM_APP_1

        move              x:(r3)+,x1  y:(r4)+,y1    ;ar br
        mpy     y1,x1,a   x:(r3)+,x0  y:(r4)+,y0    ;ar*br, ai, bi
        mac    -y0,x0,a                             ;ar*br-ai*bi
        mpy     y1,x0,b                             ;ar*bi
        mac     y0,x1,b                             ;ar*bi+ai*br
        asr a		
        asr b	a,x:(r2)+                           ;store cr
        move    b,x:(r2)+		            ;store ci

ASM_APP_2
	END_PROFILING:
ASM_APP_3

; **************************************************
	
	move	#LC0,r1
	move	a0,y:(r6)+
	move	r1,y:(r6)+
	jsr	Fprintf
	move	(r6)-
	move	(r6)-

	move	#LC1,r1
	move	b0,y:(r6)+
	move	r1,y:(r6)+
	jsr	Fprintf
	move 	(r6)-
	move	(r6)-

; **************************************************

	move	y:-(r6),ssh
	rts

	endsec

