{   
    Convolution Assembler Reference Code 

    Calling Parameters
         I0 -> First Input Data Value
         L0 =  Filter Length (N) or Taps
         I4 -> Beginning of Filter Coefficient Table
         L4 =  Filter Length (N) or Taps
         M0, M4 = 1

    Return Values
         MR0 = Filter Output y(n)
         I0 -> Oldest Input Data Value in Delay Line
         I4 -> End of Filter Coefficient Table
    
    Altered Registers
         MX0, MY0, MR
         I0, L0, M0
         I4, L4, M4
    
    Reference 
	 none

}

.MODULE                      convolution_arc;
.CONST                       N=16 ;   {filter length} ; 
.VAR/PM/RAM/ABS=0x0          coeff[N];
.INIT                        coeff: 0x0,   0x100, 0x200, 0x300, 0x400, 0x500, 
                                    0x600, 0x700, 0x800, 0x900, 0xa00, 0xb00, 
                                    0xc00, 0xd00, 0xe00, 0xf00 ;  
.VAR/DM/RAM/ABS=0x3400       data[N];
.INIT                        data:0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15;

.ENTRY conv_arc;

conv_arc:  
	 ENA M_MODE ; 
         I0=^data; L0=%coeff; M0=1 ;
         I4=^coeff; L4=%coeff; M4=1;
        
START_PROFILING:
        
	 CNTR = N-1 ;
	 MR=0, MX0=DM(I0,M0), MY0=PM(I4,M4); 
         DO conv UNTIL CE;
conv: 	 MX0=DM(I0,M0), MY0=PM(I4,M4), MR=MR+MX0*MY0(SS) ; 
         MR=MR+MX0*MY0(ss);

END_PROFILING:

end:     JUMP end ; 

.ENDMOD;
