; **************************************************
; /*
;  * benchmark program:   convolution_arc.asm
;  * 
;  * benchmark suite:     DSP-kernel
;  * 
;  * description:         convolution - filter benchmarking
;  * 
;  * reference code:      target assembly
;  * 
;  * f. verification:     with printf function
;  * 
;  *  organization:        Aachen University of Technology - IS2 
;  *                       DSP Tools Group
;  *                       phone:  +49(241)807887 
;  *                       fax:    +49(241)8888195
;  *                       e-mail: zivojnov@ert.rwth-aachen.de 
;  *
;  * author:              Juan Martinez Velarde
;  * 
;  * history:             10-5-94 creation and profiling (Martinez Velarde)
;  * 
;  */

	section convolution_arc

	opt so,nomd,cc
	
	org	x: 	; samples in x memory
F___x0: dc 1
	dc 2
	dc 3
	dc 4
	dc 5
	dc 6
	dc 7
	dc 8
	dc 9
	dc 10
	dc 11
	dc 12
	dc 13
	dc 14
	dc 15
	dc 16

	org	y:	; coefficients in y memory
F___h1:	dc 1
	dc 1
	dc 1
	dc 1	
	dc 1
	dc 1
	dc 1
	dc 1	
	dc 1
	dc 1
	dc 1
	dc 1	
	dc 1
	dc 1
	dc 1
F___hn:	dc 1

LC0
	dc	'y',$3D,$25,'i',$0A,$0A,$00
	org	p:
	global	Fmain
Fmain
	move	ssh,y:(r6)+
	move	#F___hn,r3 	
	move 	#F___x0,r4
	nop

ASM_APP_0
	START_PROFILING:
ASM_APP_1
	clr	a 	x:(r4)+,x0  y:(r3)-,y0	
	rep	#16
	mac	y0,x0,a x:(r4)+,x0  y:(r3)-,y0 	; y += *px++ * *ph--;
L14
	asr a	
	move	a0,a

ASM_APP_2
	END_PROFILING:
ASM_APP_3



; **************************************************
	move	#LC0,r1
	move	a1,y:(r6)+
	move	r1,y:(r6)+
	jsr	Fprintf
	move 	(r6)-
	move	(r6)-
; **************************************************
	move	#LC0,r1
	move	#F___x0,r4

	do	#16,L15
	move	x:(r4)+,a1
	move	a1,y:(r6)+
	move	r1,y:(r6)+
	jsr	Fprintf
	move 	(r6)-
	move	(r6)-
L15
	move	y:-(r6),ssh
	rts
	endsec
