;  benchmark program  : fir2dim_arc.asm
; 
;  benchmark suite    : DSP-kernel
;
;  description        : benchmarking of a fir2dim
;
;  reference          : none
;
;  func. verification : with sim5x simulator 
;
;  organization       : Aachen University of Technology - IS2
;                     : DSP Tools Group
;                     : phone   : +49(241)807887
;                     : fax     : +49(241)8888195
;                     : e-mail  : zivojnov@ert.rwth-aachen.de
;
;  author             : Juan Martinez Velarde
;
;  history            : 30-05-94 - assembler reference code creation 
;                       30-05-94 - assembler reference code profiling

        .mmregs

        .file  "fir2dim_arc.asm"
        .title "fir2dim filter assembler reference code"
	.width 120

N        .set         4      

	.sect "image"  ; 0x380 - 0x390
IMAGE	.word 1,1,1,1
	.word 1,1,1,1
	.word 1,1,1,1
	.word 1,1,1,1

	.sect "array"  ;  0x390 - 0x3B4
ARRAY	.word 0,0,0,0,0,0
	.word 0,1,1,1,1,0
	.word 0,1,1,1,1,0
	.word 0,1,1,1,1,0
	.word 0,1,1,1,1,0
	.word 0,0,0,0,0,0

	.sect "output"
OUTPUT	.word 0,0,0,0
      	.word 0,0,0,0
	.word 0,0,0,0
	.word 0,0,0,0

   	.sect "coeff" ; 0x0fe00 - 0x0fe08
 	.word 1,1,1
 	.word 1,1,1
 	.word 1,1,1

COEFF1	.set 	0fe00h
COEFF2	.set 	0fe03h
COEFF3	.set 	0fe06h

        .sect ".text"
INIT:				; program entry point
	LDP	#0
	LAR	AR5,#OUTPUT
	LAR	AR6,#ARRAY

START_PROFILING:
	
	LAR	AR0,#N-1	; set up loop count N

LOOP2:  SPLK	#N-1,BRCR	; second loop 

	RPTB	ELOOP1-1	; repeat loop block

	SAR	AR6,AR2		    ; ar2 = ar6
	MAR	*,AR2		    ; arp = ar2
        RPTZ	#2		    ; do it 3 times
        MAC	COEFF1,*+           ; PREG = *AR2++ * coeff++

	SAR	AR2,AR3		    ; ar3 = ar2
	MAR	*,AR3		    ; arp = ar3 
        APAC 			    ; add P register to Accu
	ZPR			    ; clear P register
	ADRK	(N-1)		    ; update pointer AR3
	RPT	#2		    ; do it 3 times
        MAC	COEFF2,*+           ; PREG = *AR3++ * coeff++

	SAR	AR3,AR4		    ; ar4 = ar3
	MAR	*,AR4		    ; arp = ar4
        APAC                        ; add P register to Accu
	ZPR			    ; clear P register
	ADRK	(N-1)		    ; update pointer AR4
	RPT	#2		    ; do it 3 times
        MAC	COEFF3,*+           ; PREG = *AR4++ * coeff++
        APAC                        ; add P register to Accu

	MAR	*,AR5		    ; arp = ar5
        SACL    *+,0,AR6            ; store the lower 16 bits
                                    ; accu as filter output
	MAR	*+,AR6		    ; next column
ELOOP1:	
	ADRK	(N-2)		    ; update to next row
	MAR	*,AR0		    ; arp = ar0
	BANZ	LOOP2,*-	    ; branch, arp = ar2

END_PROFILING:

END:        B END

        .end
