;/*
; * benchmark program:   real_update_arc.asm
; * 
; * benchmark suite:     DSP-kernel
; * 
; * description:         real_update - filter benchmarking
; * 
; * This program performs a real update of the form D = C + A*B,
; * where A, B, C and D are real numbers .
; * 
; * reference code:      target assembly
; * 
; * f. verification:     simulator based
; * 
; *  organization:        Aachen University of Technology - IS2 
; *                       DSP Tools Group
; *                       phone:  +49(241)807887 
; *                       fax:    +49(241)8888195
; *                       e-mail: zivojnov@ert.rwth-aachen.de 
; *
; * author:              Juan Martinez Velarde
; * 
; * history:             11-5-94 creation (Martinez Velarde)
; * 
; */
	section real_update_arc
	opt	so,nomd,cc

        org     x:$0
V__a:   dc      4194303

V__c:   dc      1

        org     y:$0
V__b:   dc      2

V__d:   dc      0


LC0	dc	'd',$3D,$25,'i',$0A,$0A,$00


	org	p:
	global	Fmain
Fmain
	move	ssh,y:(r6)+

        move 	#V__a,r3
	move	#V__d,r2
        move 	#V__c,r1
	move	#V__b,r4
	clr	a
	nop

	START_PROFILING:

        move            x:(r1),a	           ;a=cr
	move	a,a0                       ;
	asl	a	x:(r3)+,x1  y:(r4)+,y1   ;x1=ar,y1=br
        mac    	y1,x1,a                            ;a-=ai*bi
	asr 	a                                  ;
	move            a0,y:(r2)                  ;store b

	END_PROFILING:

; **************************************************
	
	clr 	a
	move	y:(r2),a0
	move	#LC0,r1
	move	a0,y:(r6)+
	move	r1,y:(r6)+
	jsr	Fprintf
	move 	(r6)-
	move	(r6)-

; **************************************************

	move	y:-(r6),ssh
	rts
	endsec